## lomiri-location-service 3.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(lomiri-location-service VERSION 3.3.0 LANGUAGES C CXX)

# This version is for the API version (i.e. library's SOVERSION).
set(LOMIRI_LOCATION_SERVICE_VERSION_MAJOR 3)
set(LOMIRI_LOCATION_SERVICE_VERSION_MINOR 0)
set(LOMIRI_LOCATION_SERVICE_VERSION_PATCH 0)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

message(STATUS "${CMAKE_PROJECT_NAME} ${LOMIRI_LOCATION_SERVICE_VERSION_MAJOR}.${LOMIRI_LOCATION_SERVICE_VERSION_MINOR}.${LOMIRI_LOCATION_SERVICE_VERSION_PATCH}")

set(LOMIRI_LOCATION_SERVICE_TRUST_STORE_SERVICE_NAME "LomiriLocationService")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -pedantic -Wextra -fPIC")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -Wall -fno-strict-aliasing -pedantic -Wextra -fPIC -DBOOST_ASIO_DISABLE_EPOLL")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option (ENABLE_TRUST_STORE "Enable support for trust-store" ON)

include(cmake/EnableCoverageReport.cmake)
include(cmake/FindGFlags.cmake)
include(cmake/FindGLog.cmake)
include(CTest)

include(GNUInstallDirs)

find_package(PkgConfig)
find_package(Boost COMPONENTS filesystem system program_options)
find_package(GLog)
find_package(GFlags)
find_package(Threads)
pkg_check_modules(DBUS dbus-1 REQUIRED)
pkg_check_modules(DBUS_CPP dbus-cpp REQUIRED)
pkg_check_modules(JSON_C json-c REQUIRED)
pkg_check_modules(LIBAPPARMOR libapparmor REQUIRED)
pkg_check_modules(NET_CPP net-cpp REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(PROPERTIES_CPP properties-cpp REQUIRED)
if (ENABLE_TRUST_STORE)
    pkg_check_modules(TRUST_STORE trust-store REQUIRED)
endif (ENABLE_TRUST_STORE)
pkg_check_modules(UBUNTU_PLATFORM_HARDWARE_API ubuntu-platform-hardware-api)
pkg_check_modules(GPSD libgps)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

option (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS "Disable errors when local typedefs are unused" ON)
if (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=unused-local-typedefs")
endif (DISABLE_ERROR_ON_LOCAL_TYPEDEFS_WARNINGS)

#
# Code style fixer. We rely on clang-format to adjust the formatting of source code.
#
find_program(CLANG_FORMAT_COMMAND NAMES clang-format-3.6 clang-format-3.5)
if (NOT CLANG_FORMAT_COMMAND)
  message(WARNING "Cannot find clang-format >= clang-format-3.5: formatcode target will not be available")
endif()

if (CLANG_FORMAT_COMMAND)
  file(GLOB_RECURSE LOMIRI_LOCATION_SERVICE_INTERFACE_HEADER_FILES ${CMAKE_SOURCE_DIR}/include/*.h)
  file(GLOB_RECURSE LOMIRI_LOCATION_SERVICE_IMPLEMENTATION_FILES ${CMAKE_SOURCE_DIR}/src/*.h ${CMAKE_SOURCE_DIR}/src/*.cpp)
  add_custom_target(formatcode ${CLANG_FORMAT_COMMAND} -i ${LOMIRI_LOCATION_SERVICE_INTERFACE_HEADER_FILES} ${LOMIRI_LOCATION_SERVICE_IMPLEMENTATION_FILES} SOURCES _clang-format)
endif()

include_directories(
  3rd-party/

  ${Boost_INCLUDE_DIRS}
  ${DBUS_INCLUDE_DIRS}
  ${DBUS_CPP_INCLUDE_DIRS}
  ${JSON_C_INCLUDE_DIRS}
  ${LIBAPPARMOR_INCLUDE_DIRS}
  ${NET_CPP_INCLUDE_DIRS}
  ${PROPERTIES_CPP_INCLUDE_DIRS}
  ${PROCESS_CPP_INCLUDE_DIRS}
  ${TRUST_STORE_INCLUDE_DIRS}
  ${GLog_INCLUDE_DIR}
  ${GFlags_INCLUDE_DIR}

  ${CMAKE_SOURCE_DIR}/include/location_service
  ${CMAKE_SOURCE_DIR}/src/location_service
  ${CMAKE_BINARY_DIR}/src/location_service
)

set(LOMIRI_LOCATION_SERVICE_PUBLIC_HEADERS
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/boost_ptree_settings.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/connectivity/cached_radio_cell.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/connectivity/cached_wireless_network.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/connectivity/dummy_connectivity_manager.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/connectivity/nm.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/connectivity/ofono.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/connectivity/ofono_nm_connectivity_manager.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/engine.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/non_selecting_provider_selection_policy.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/dummy/delayed_provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/dummy/provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/geoclue/geoclue.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/geoclue/provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/android_hardware_abstraction_layer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/hardware_abstraction_layer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/net_cpp_gps_xtra_downloader.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/null_gps_xtra_downloader.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/sntp_client.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gps/sntp_reference_time_source.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/gpsd/provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/remote/provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/providers/skyhook/provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/always_granting_permission_manager.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/daemon.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/dbus_connection_factory.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/default_configuration.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/demultiplexing_reporter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/harvester.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/ichnaea_reporter.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/implementation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/program_options.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/provider_daemon.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/runtime.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/runtime_tests.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/session/interface_p.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/set_name_for_thread.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/settings.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/state_tracking_provider.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/time_based_update_policy.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/time_since_boot.h
  ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/update_policy.h
)
if(ENABLE_TRUST_STORE)
  set(LOMIRI_LOCATION_SERVICE_PUBLIC_HEADERS
    ${LOMIRI_LOCATION_SERVICE_PUBLIC_HEADERS}
    ${CMAKE_CURRENT_SOURCE_DIR}/src/location_service/com/lomiri/location/service/trust_store_permission_manager.h
  )
endif(ENABLE_TRUST_STORE)

add_subdirectory(data)
add_subdirectory(doc)
add_subdirectory(examples)
add_subdirectory(include)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(qt)

# There's no nice way to format this. Thanks CMake.
add_test(LGPL-required
  /bin/sh -c "! grep -rl 'GNU General' ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/include"
)

enable_coverage_report(service)

=== data/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

configure_file(
  lomiri-location-service.pc.in lomiri-location-service.pc @ONLY
)

configure_file(
  lomiri-location-service-connectivity.pc.in lomiri-location-service-connectivity.pc @ONLY
)

configure_file(
  lomiri-location-service.service.in lomiri-location-service.service @ONLY
)

configure_file(
  lomiri-location-service-trust-stored.service.in lomiri-location-service-trust-stored.service @ONLY
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-location-service.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-location-service-connectivity.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install(
  FILES ${CMAKE_CURRENT_SOURCE_DIR}/com.lomiri.location.Service.conf
  DESTINATION /etc/dbus-1/system.d/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-location-service.service
  DESTINATION /lib/systemd/system/
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-location-service-trust-stored.service
  DESTINATION /usr/lib/systemd/user/
)

=== doc/CMakeLists.txt ===
# Copyright © 2013 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Thomas Voss <thomas.voss@canonical.com>

find_package(Doxygen)

if(DOXYGEN_FOUND)
  configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in 
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc ALL 
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM)
  install(
    DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
    DESTINATION share/doc/${PROJECT_NAME})
endif(DOXYGEN_FOUND)

=== include/CMakeLists.txt ===
install(
    DIRECTORY location_service/com
    DESTINATION include/lomiri-location-service-${LOMIRI_LOCATION_SERVICE_VERSION_MAJOR}
)

=== po/CMakeLists.txt ===
include(FindGettext)
find_program(GETTEXT_XGETTEXT_EXECUTABLE xgettext)

set(DOMAIN ${PROJECT_NAME})
set(POT_FILE ${DOMAIN}.pot)

file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS LINGUAS
     REGEX "^[^#].*")
string(REGEX MATCHALL "[^ \t]+" LANGS "${LINGUAS}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
               ${CMAKE_CURRENT_BINARY_DIR}/POTFILES COPYONLY
)

add_custom_target(${POT_FILE} ALL
    COMMENT "Generating translation template..."
    COMMAND ${GETTEXT_XGETTEXT_EXECUTABLE} -o ${CMAKE_CURRENT_SOURCE_DIR}/${POT_FILE}
        -D ${CMAKE_SOURCE_DIR}
        --from-code=UTF-8
        --c++ --qt --add-comments=TRANSLATORS
        --keyword=tr --keyword=tr:1,2 --keyword=N_ --keyword=_ --keyword=tag --keyword=tag:1c,2
        --package-name='${PROJECT_NAME}'
        --copyright-holder='Canonical Ltd.'
        --join-existing
        --files-from=${CMAKE_CURRENT_BINARY_DIR}/POTFILES
)

foreach(LANG ${LANGS})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${LANG}.po
                   ${CMAKE_CURRENT_BINARY_DIR}/${LANG}.po
                   COPYONLY
    )
endforeach(LANG)
gettext_process_pot_file(${POT_FILE} ALL
                         INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
                         LANGUAGES ${LANGS}
)

=== qt/CMakeLists.txt ===
add_subdirectory(position)

=== tests/CMakeLists.txt ===
find_package(Threads)

add_definitions(-DCORE_DBUS_ENABLE_GOOGLE_TEST_FIXTURE -DBOOST_ASIO_DISABLE_MOVE)

option(
    LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER
    "Rely on dbus test runner to start a private session for testing purposes"
    ON
)

if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    find_program(DBUS_TEST_RUNNER_EXECUTABLE dbus-test-runner)
    message(STATUS "Executing test suite under dbus-test-runner")
endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)

# Build mongoose as static library to leverage in location reporter testing
add_library(mongoose mongoose.c)
# Explicitly select c99 when compiling mongoose
set_target_properties(
    mongoose
    PROPERTIES COMPILE_FLAGS "-std=c99")

# Build with system gmock and embedded gtest
find_package(GMock)

macro(LOCATION_SERVICE_ADD_TEST test_name src)
  add_executable(
    ${test_name}
    ${src})

  target_link_libraries(
    ${test_name}

    lomiri-location-service
    lomiri-location-service-connectivity
    lomiri-location-service-provider-daemon
    lomiri-location-service-daemon

    mongoose

    ${Boost_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}

    ${PROCESS_CPP_LIBRARIES}

    ${ARGN}

    ${GMOCK_LIBRARIES}
    ${GTEST_BOTH_LIBRARIES})

  add_test(${test_name} ${CMAKE_CURRENT_BINARY_DIR}/${test_name} --gtest_filter=*-*requires*)

  # Address android's limit on cmdline length and distill lomiri-location-service into lls
  install(
    TARGETS ${test_name}
    DESTINATION /usr/libexec/lls-tests
  )
endmacro(LOCATION_SERVICE_ADD_TEST)

include_directories (
  ${CMAKE_SOURCE_DIR}/src/location_service

  ${GMOCK_INCLUDE_DIR}
  ${GTEST_INCLUDE_DIR}
)

LOCATION_SERVICE_ADD_TEST(acceptance_tests acceptance_tests.cpp)
LOCATION_SERVICE_ADD_TEST(boost_ptree_settings_test boost_ptree_settings_test.cpp)
LOCATION_SERVICE_ADD_TEST(connectivity_manager_test connectivity_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(controller_test controller_test.cpp)
LOCATION_SERVICE_ADD_TEST(criteria_test criteria_test.cpp)
LOCATION_SERVICE_ADD_TEST(daemon_and_cli_tests daemon_and_cli_tests.cpp)
LOCATION_SERVICE_ADD_TEST(default_permission_manager_test default_permission_manager_test.cpp)
LOCATION_SERVICE_ADD_TEST(engine_test engine_test.cpp)
LOCATION_SERVICE_ADD_TEST(harvester_test harvester_test.cpp)
LOCATION_SERVICE_ADD_TEST(demultiplexing_reporter_test demultiplexing_reporter_test.cpp)
LOCATION_SERVICE_ADD_TEST(time_based_update_policy_test time_based_update_policy_test.cpp)

if (NET_CPP_FOUND)
  LOCATION_SERVICE_ADD_TEST(ichnaea_reporter_test ichnaea_reporter_test.cpp)
endif()

LOCATION_SERVICE_ADD_TEST(position_test position_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_selection_policy_test provider_selection_policy_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_factory_test provider_factory_test.cpp)
LOCATION_SERVICE_ADD_TEST(provider_test provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(wgs84_test wgs84_test.cpp)
LOCATION_SERVICE_ADD_TEST(runtime_test runtime_test.cpp)
LOCATION_SERVICE_ADD_TEST(state_tracking_provider_test state_tracking_provider_test.cpp)

if (ENABLE_TRUST_STORE)
  LOCATION_SERVICE_ADD_TEST(trust_store_permission_manager_test trust_store_permission_manager_test.cpp)
endif (ENABLE_TRUST_STORE)

# Provider-specific test-cases go here.
if (LOCATION_SERVICE_ENABLE_GPS_PROVIDER)
  include_directories(${CMAKE_SOURCE_DIR}/src/location_service)
  LOCATION_SERVICE_ADD_TEST(gps_provider_test gps_provider_test.cpp)
  LOCATION_SERVICE_ADD_TEST(sntp_client_test sntp_client_test.cpp)
endif(LOCATION_SERVICE_ENABLE_GPS_PROVIDER)

if (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)
  add_executable(geoclue_provider_test geoclue_provider_test.cpp)
  target_link_libraries(
    geoclue_provider_test

    lomiri-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${PROCESS_CPP_LIBRARIES}

    ${GTEST_BOTH_LIBRARIES}
  )
  if (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${DBUS_TEST_RUNNER_EXECUTABLE} --task=${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  else (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
    add_test(geoclue_provider_test ${CMAKE_CURRENT_BINARY_DIR}/geoclue_provider_test)
  endif (LOCATION_SERVICE_ENABLE_DBUS_TEST_RUNNER)
endif (LOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDERS)

LOCATION_SERVICE_ADD_TEST(remote_providerd_test remote_providerd_test.cpp)

LOCATION_SERVICE_ADD_TEST(remote_provider_test remote_provider_test.cpp)
LOCATION_SERVICE_ADD_TEST(delayed_service_test delayed_service_test.cpp)

LOCATION_SERVICE_ADD_TEST(bug_1447110 bug_1447110.cpp)

=== examples/service/CMakeLists.txt ===
message(STATUS ${Boost_LIBRARIES})
include_directories(
    ${Boost_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${DBUS_CPP_INCLUDE_DIRS}

)

link_directories(
  /tmp/wpsapi-4.7.6_05-linux-x86_64/lib
)

add_executable(
    client
    client.cpp
)

add_executable(
    service
    service.cpp
)

target_link_libraries(
    client

    lomiri-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    ${DBUS_CPP_LDFLAGS}
)

target_link_libraries(
    service

    lomiri-location-service

    ${CMAKE_THREAD_LIBS_INIT}
    ${Boost_LIBRARIES}
    ${DBUS_LIBRARIES}
    ${DBUS_CPP_LDFLAGS}
)

add_custom_command(
    OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/lomiri-location-service.1"
    COMMAND ronn --roff --pipe --organization=ubports ${CMAKE_CURRENT_SOURCE_DIR}/service.1.ronn > ${CMAKE_CURRENT_BINARY_DIR}/lomiri-location-service.1
)

add_custom_target(
    lomiri-location-service-man-page
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/lomiri-location-service.1"
)

install(
    TARGETS service client
    DESTINATION ${CMAKE_INSTALL_LIBEXECDIR}/examples/
)

install(
    FILES ${CMAKE_CURRENT_SOURCE_DIR}/lomiri-location-service.1
    DESTINATION share/doc/${CMAKE_PROJECT_NAME}/man
)

=== qt/position/CMakeLists.txt ===
find_package(PkgConfig)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Location REQUIRED)

qt5_add_resources(POSITION_RESOURCES position.qrc)

add_library(
  qtposition_lomiri SHARED

  core_geo_position_info_source.h
  core_geo_position_info_source_factory.h

  core_geo_position_info_source.cpp
  core_geo_position_info_source_factory.cpp

  ${POSITION_RESOURCES}
)

target_compile_definitions(qtposition_lomiri PRIVATE QT_NO_KEYWORDS)

# Ideally, we would read the plugin installation location from cmake
# but this does not work currently.
set(PLUGIN_INSTALL_LOCATION "${CMAKE_INSTALL_LIBDIR}/qt5/plugins/position")
# get_target_property(PLUGIN_LOCATION Qt5::Location PLUGIN_LOCATION)

message(STATUS "Installing Qt5 location plugin to: ${PLUGIN_INSTALL_LOCATION}")

target_link_libraries(
  qtposition_lomiri

  ${CMAKE_THREAD_LIBS_INIT}

  Qt5::Core
  Qt5::Gui
  Qt5::Location

  lomiri-location-service
  ${DBUS_CPP_LDFLAGS}
)

install(
  TARGETS qtposition_lomiri
  LIBRARY DESTINATION ${PLUGIN_INSTALL_LOCATION})

=== examples/standalone/connectivity/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(connectivity)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

find_package(GLog)
find_package(PkgConfig)
find_package(Threads)

pkg_check_modules(
  DBUS_CPP 
  dbus-cpp REQUIRED)

pkg_check_modules(
  PROCESS_CPP 
  process-cpp REQUIRED)

pkg_check_modules(
  LOCATION_CONNECTIVITY 
  lomiri-location-service-connectivity REQUIRED)

include_directories(
  ${DBUS_CPP_INCLUDE_DIRS}
  ${GLog_INCLUDE_DIR}
  ${PROCESS_CPP_INCLUDE_DIRS}
  ${LOCATION_CONNECTIVITY_INCLUDE_DIRS})

add_executable(
  connectivity

  connectivity.cpp)

target_link_libraries(
  connectivity

  ${CMAKE_THREAD_LIBS_INIT}

  ${DBUS_CPP_LDFLAGS}
  ${GLog_LIBRARY}
  ${PROCESS_CPP_LDFLAGS}
  ${LOCATION_CONNECTIVITY_LDFLAGS})

=== src/location_service/com/lomiri/location/CMakeLists.txt ===
if (NET_CPP_FOUND)
  add_definitions(-DCOM_LOMIRI_LOCATION_SERVICE_HAVE_NET_CPP=1)

  set(ICHNAEA_REPORTER_SRCS service/ichnaea_reporter.cpp)
endif()

add_subdirectory(providers)

configure_file(
  service/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/service/config.h @ONLY
)

include_directories(${UBUNTU_PLATFORM_HARDWARE_API_INCLUDE_DIRS})

set(LOMIRI_LOCATION_SERVICE_SRCS
  default_provider_selection_policy.cpp
  fusion_provider_selection_policy.cpp
  non_selecting_provider_selection_policy.cpp

  criteria.cpp
  engine.cpp
  fusion_provider.cpp
  init_and_shutdown.cpp
  position.cpp
  provider.cpp
  provider_factory.cpp
  proxy_provider.cpp
  satellite_based_positioning_state.cpp
  settings.cpp
  state_tracking_provider.h
  time_based_update_policy.cpp
  set_name_for_thread.cpp
  time_since_boot.cpp
  wifi_and_cell_reporting_state.cpp

  boost_ptree_settings.cpp

  service/default_configuration.cpp
  service/default_permission_manager.cpp
  service/harvester.cpp
  service/demultiplexing_reporter.h
  service/demultiplexing_reporter.cpp
  service/runtime.cpp
  service/runtime_tests.h
  service/runtime_tests.cpp
  service/state.cpp
  service/system_configuration.cpp

  service/implementation.cpp
  service/skeleton.cpp
  service/stub.cpp

  service/session/implementation.cpp
  service/session/interface.cpp
  service/session/skeleton.cpp
  service/session/stub.cpp

  providers/config.cpp

  providers/remote/provider.cpp
  providers/remote/skeleton.cpp
  providers/remote/stub.cpp

  ${ICHNAEA_REPORTER_SRCS}
)
if(ENABLE_TRUST_STORE)
  set(LOMIRI_LOCATION_SERVICE_SRCS
   ${LOMIRI_LOCATION_SERVICE_SRCS}
   service/trust_store_permission_manager.cpp
  )
endif(ENABLE_TRUST_STORE)

add_library(
  lomiri-location-service SHARED

  ${LOMIRI_LOCATION_SERVICE_PUBLIC_HEADERS}

  ${LOMIRI_LOCATION_SERVICE_SRCS}
)

add_library(
  lomiri-location-service-connectivity SHARED

  set_name_for_thread.cpp

  connectivity/cached_radio_cell.cpp
  connectivity/cached_wireless_network.cpp
  connectivity/manager.cpp
  connectivity/radio_cell.cpp
  connectivity/wireless_network.cpp

  connectivity/ofono_nm_connectivity_manager.cpp
)

set(symbol_map "${CMAKE_SOURCE_DIR}/symbols.map")

set_target_properties(
  lomiri-location-service

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${LOMIRI_LOCATION_SERVICE_VERSION_MAJOR}.${LOMIRI_LOCATION_SERVICE_VERSION_MINOR}.${LOMIRI_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${LOMIRI_LOCATION_SERVICE_VERSION_MAJOR}
)

set_target_properties(
  lomiri-location-service-connectivity

  PROPERTIES
  LINK_FLAGS "${ldflags} -Wl,--version-script,${symbol_map}"
  LINK_DEPENDS ${symbol_map}
  VERSION ${LOMIRI_LOCATION_SERVICE_VERSION_MAJOR}.${LOMIRI_LOCATION_SERVICE_VERSION_MINOR}.${LOMIRI_LOCATION_SERVICE_VERSION_PATCH}
  SOVERSION ${LOMIRI_LOCATION_SERVICE_VERSION_MAJOR}
)

add_definitions(${ENABLED_PROVIDER_TARGETS_DEFINITIONS})

if(ENABLE_TRUST_STORE)
  target_compile_definitions(lomiri-location-service PRIVATE ENABLE_TRUST_STORE)
endif(ENABLE_TRUST_STORE)

target_link_libraries(
  lomiri-location-service-connectivity

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${PROCESS_CPP_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  lomiri-location-service

  lomiri-location-service-connectivity

  ${ENABLED_PROVIDER_TARGETS}

  ${CMAKE_THREAD_LIBS_INIT}
  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LDFLAGS}
  ${JSON_C_LDFLAGS}
  ${LIBAPPARMOR_LDFLAGS}
  ${NET_CPP_LDFLAGS}
  ${TRUST_STORE_LDFLAGS}
  ${UBUNTU_PLATFORM_HARDWARE_API_LDFLAGS}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS lomiri-location-service
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  TARGETS lomiri-location-service-connectivity
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

add_library(
  lomiri-location-service-provider-daemon

  service/provider_daemon.cpp
)

add_library(
  lomiri-location-service-daemon

  service/daemon.cpp
)

add_executable(
  lomiri-location-service-providerd

  service/provider_daemon_main.cpp
)

add_executable(
  lomiri-location-serviced

  service/daemon_main.cpp
)

add_executable(
  lomiri-location-serviced-cli

  service/daemon_cli_main.cpp
)

target_link_libraries(
  lomiri-location-service-provider-daemon

  lomiri-location-service
)

target_link_libraries(
  lomiri-location-service-daemon

  lomiri-location-service
)

target_link_libraries(
  lomiri-location-service-providerd

  lomiri-location-service-provider-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  lomiri-location-serviced

  lomiri-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

target_link_libraries(
  lomiri-location-serviced-cli

  lomiri-location-service-daemon

  ${ENABLED_PROVIDER_TARGETS}

  ${Boost_LIBRARIES}
  ${DBUS_LIBRARIES}
  ${DBUS_CPP_LIBRARIES}
  ${GLog_LIBRARY}
  ${GFlags_LIBRARY}
)

install(
  TARGETS lomiri-location-service-providerd
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS lomiri-location-serviced
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(
  TARGETS lomiri-location-serviced-cli
  DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== src/location_service/com/lomiri/location/providers/CMakeLists.txt ===
add_subdirectory(dummy)
add_subdirectory(remote)
add_subdirectory(geoclue)
add_subdirectory(gps)
add_subdirectory(gpsd)
add_subdirectory(skyhook)

set(
  ENABLED_PROVIDER_TARGETS
  ${ENABLED_PROVIDER_TARGETS}
  PARENT_SCOPE
)

set(
  ENABLED_PROVIDER_TARGETS_DEFINITIONS
  ${ENABLED_PROVIDER_TARGETS_DEFINITIONS}
  PARENT_SCOPE
)

=== debian/changelog ===
lomiri-location-service (3.3.0-2build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:27:14 +0200

lomiri-location-service (3.3.0-2) unstable; urgency=medium

  * debian/control:
    + Drop from D: (lomiri-location-service-bin): trust-store-bin. (Closes:
      #1096125).

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 20 Feb 2025 12:49:20 +0100

lomiri-location-service (3.3.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #1095416).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 08 Feb 2025 10:27:52 +0100

=== debian/control ===
Source: lomiri-location-service
Section: utils
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               curl,
               libdbus-cpp-dev (>= 4.1.0),
               debhelper-compat (= 13),
               doxygen <!nodoc>,
               google-mock (>= 1.6.0+svn437),
               graphviz <!nodoc>,
               libapparmor-dev,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libdbus-1-dev,
               libgoogle-glog-dev,
               libgps-dev,
               libgtest-dev,
               libiw-dev,
               libjson-c-dev,
               libnet-cpp-dev,
               libprocess-cpp-dev,
               libproperties-cpp-dev,
               lsb-release,
               qtbase5-dev,
               qtlocation5-dev,
               qtpositioning5-dev,
               rdfind,
               symlinks,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/lomiri-location-service
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-location-service.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-location-service

Package: liblomiri-location-service3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Location Service client library
 Aggregates position/velocity/heading updates and exports them over DBus.
 .
 This package contains the shared library needed by client applications.

Package: liblomiri-location-service-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-location-service3 (= ${binary:Version}),
         libdbus-1-dev,
         libdbus-cpp-dev,
         libboost-dev,
         ${misc:Depends},
Suggests: lomiri-location-service-doc,
Description: Lomiri Location Service (development files)
 Aggregates position/velocity/heading updates and exports them over DBus.
 .
 This package contains header files required to develop clients talking to the
 Lomiri Location Service.

Package: lomiri-location-service-tests
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Location Service test executables
 Aggregates position/velocity/heading updates and exports them over DBus.
 .
 This package contains all test executables.

Package: lomiri-location-service-bin
Architecture: any
Depends: liblomiri-location-service3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Lomiri Location Service binaries
 Aggregates position/velocity/heading updates and exports them over DBus.
 .
 This package contains the service executable and man pages.

Package: lomiri-location-service-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Build-Profiles: <!nodoc>
Recommends: lomiri-location-service-examples,
Description: Lomiri Location Service documentation
 Aggregates position/velocity/heading updates and exports them over DBus.
 .
 This package contains documentation for the service and client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

NULL =

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/share/dbus-1
	mv debian/tmp/etc/dbus-1/system.d/ debian/tmp/usr/share/dbus-1/
	mv debian/tmp/lib/systemd/system/ debian/tmp/usr/lib/systemd/

override_dh_install:
	rm -Rv debian/tmp/usr/lib/*/lomiri-location-service/examples/
	rm -Rv debian/tmp/usr/share/lomiri-location-service/examples/
	cd debian/tmp/usr/share/doc/lomiri-location-service/html/ && rdfind -makesymlinks true .
	cd debian/tmp/usr/share/doc/lomiri-location-service/html/ && symlinks -rc .
	dh_install -Xlomiri-location-service.1

override_dh_auto_configure:
	if [ ! -e po/lomiri-location-service.pot.deb-bak ]; then cp po/lomiri-location-service.pot po/lomiri-location-service.pot.deb-bak; fi
	dh_auto_configure -- \
	        -DCMAKE_INSTALL_LIBEXECDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/lomiri-location-service \
	        -DCMAKE_C_COMPILER=$(CC) \
	        -DCMAKE_CXX_COMPILER=$(CXX) \
	        -DENABLE_TRUST_STORE=OFF \
	        -DLOCATION_SERVICE_ENABLE_GPS_PROVIDER=OFF \
	        -DLOCATION_SERVICE_ENABLE_GEOCLUE_PROVIDER=ON \
	        $(NULL)

override_dh_auto_test:
	# Don't run tests in parallel as fake web servers all bind to same port
	dh_auto_test --no-parallel -- ARGS+="-E '^(remote_providerd_test|delayed_service_test|daemon_and_cli_tests)'"

override_dh_clean:
	-mv po/lomiri-location-service.pot.deb-bak po/lomiri-location-service.pot
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
